#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <hamsandwich>

#define VERSION "0.0.2"

#define CSW_SHIELD 2

// CWeaponBox pdata
const XO_CWEAPONBOX = 4;
new const m_rgpPlayerItems_CWeaponBox[4] = {35, 36, 38, 39};

// CBasePlayerItem pdata
const XO_CBASEPLAYERITEM = 4;
const m_iId = 43;

new g_WeaponBoxBits;
new Float:g_WeaponBoxLife[CSW_P90+1];

new HamHook:g_HookShield, HamHook:g_HookWeapon;

public plugin_init()
{
	register_plugin("WeaponBox Life", VERSION, "11922911");
	
	register_concmd("weaponbox_life", "ConCmd_SetLife", ADMIN_CFG, "<weapon short name> <remove time>");
	
	DisableHamForward(g_HookShield = RegisterHam(Ham_Touch, "weapon_shield", "On_Shield_Touch"));
	DisableHamForward(g_HookWeapon = RegisterHam(Ham_Touch, "weaponbox",     "On_Weapon_Touch"));
}

public ConCmd_SetLife( id, level, cid )
{
	if( !cmd_access(id, level, cid, 2) )
	
		
		if( value >= 0.0 )
		{
			g_WeaponBoxBits = 536870910; // 1 .. 30 & ~29
			EnableHamForward(g_HookShield);
			EnableHamForward(g_HookWeapon);
		}
		else
		{
			g_WeaponBoxBits = 0;
			DisableHamForward(g_HookShield);
			DisableHamForward(g_HookWeapon);
		}
	}
	else
	{
		new weaponId = CSW_SHIELD, HamHook:hook = g_HookShield;
		if( !equal(argument[7], "shield") )
		{
			weaponId = get_weaponid(argument);
			if( !weaponId || weaponId == CSW_KNIFE ) return PLUGIN_HANDLED;
			hook = g_HookWeapon;
		}
		
		read_argv(2, argument, charsmax(argument));
		g_WeaponBoxLife[weaponId] = str_to_float(argument);
		
		if( g_WeaponBoxLife[weaponId] >= 0.0 )
		{
			g_WeaponBoxBits |= 1 << weaponId;
			EnableHamForward(hook);
		}
		else
		{
			g_WeaponBoxBits &= ~(1 << weaponId);
			if( !g_WeaponBoxBits || weaponId == CSW_SHIELD ) DisableHamForward(hook);
		}
	}
	
	return PLUGIN_HANDLED;
}

public On_Weapon_Touch( weaponBox )
{
	new weaponId = get_weaponbox_type(weaponBox);
	if( weaponId && g_WeaponBoxBits & 1 << weaponId && pev(weaponBox, pev_bInDuck) != 1 )
	{
		set_pev(weaponBox, pev_bInDuck, 1);
		set_pev(weaponBox, pev_nextthink, get_gametime() + g_WeaponBoxLife[weaponId]);
	}
}

public On_Shield_Touch( weaponBox )
{
	if( pev(weaponBox, pev_bInDuck) != 1 )
	{
		set_pev(weaponBox, pev_bInDuck, 1);
		set_pev(weaponBox, pev_nextthink, get_gametime() + g_WeaponBoxLife[CSW_SHIELD]);
	}
}

// Cstrike Pdatas and Offsets library
stock get_weaponbox_type( weaponBox )
{	
	new weapon;
	for( new i; i < 4; i++ )
	{
		weapon = get_pdata_cbase(weaponBox, m_rgpPlayerItems_CWeaponBox[i], XO_CWEAPONBOX);
		if( weapon > 0 )
			return get_pdata_int(weapon, m_iId, XO_CBASEPLAYERITEM);
	}
	
	return 0;
}